/*
 Nome: DESCRICAO_CFOP

 Descrio:
  Funo para retornar a descrio do CFOP.

 Criao:
 19/06/2012 - Marcelo Alexsandro Souza Silva
*/

IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'DESCRICAO_CFOP' AND
                 TYPE = 'FN' 		          AND
	              U.UID = O.UID             AND
	              U.NAME = USER)
DROP FUNCTION DESCRICAO_CFOP
GO

CREATE FUNCTION DESCRICAO_CFOP
(@P_CDFISCOPER VARCHAR(10)) RETURNS VARCHAR(500)
AS
BEGIN
   DECLARE @V_DESCRICAO VARCHAR(500);
   SELECT @V_DESCRICAO = MAX(CONVERT(VARCHAR(500), DSCFOPPADRAO))
     FROM CFOPPADRAO
    WHERE CDCFOPPADRAO = @P_CDFISCOPER;
   RETURN (@V_DESCRICAO);
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'DESCRICAO_CFOP','5.75.xxx';
GO

