function LayoutController(General, ScreenService, ColorPickerController, restEngine, templateManager) {

	var self = this;
	var TAMANHO_FONTE_PADRAO = '08';

	this.setCicloColor = function(element, row, fieldName) {
		if (("" + row[fieldName]).charAt(0) != '#')
			self.convertTColorToHexa(row);
		if (row) {
			if (element.hasClass('zh-span-field ng-scope')) {
				element.find('p').css('background-clip', 'content-box');
				element.find('p').css('background-color', '#' + row[fieldName]);
				element.find('p').css('color', '#' + row[fieldName]);
			}
			else if (element.hasClass('td zh-standard-column  grid-align-left')) {
				element.find('p').css('background-clip', 'content-box');
				element.find('span').css('background-color', '#' + row[fieldName]);
				element.find('span').css('color', '#' + row[fieldName]);
				element.find('span').css('display', 'block');
			}
		}
	};
 
	this.convertTColorToHexa = function(row) {
		if (!isNaN(row.NRCOLORBACK)) {
			row.NRCOLORBACK = this.colorChange(row.NRCOLORBACK);
		}
		if (!isNaN(row.NRCOLORTEXT)) {
			row.NRCOLORTEXT = this.colorChange(row.NRCOLORTEXT);
		}
	};

	this.colorChange = function(Cor) {
		var r = Cor & 0XFF;
		var g = (Cor >> 8) & 0xFF;
		var b = (Cor >> 16) & 0XFF;
		var Hexa = "#" + ((1 << 24) + (Math.floor(r) << 16) + (Math.floor(g) << 8) + Math.floor(b)).toString(16).slice(1);
		return Hexa;
	};

	this.newRowGruposDeProdutos = function(args) {
		var widget = args.owner.widget;
		if(widget.bkpRow)
			 widget.currentRow = widget.bkpRow;
		var row = widget.currentRow; 
		 widget.bkpRow = Util.clone(widget.currentRow); 
		General.widgetNewRow(widget);
		
		widget.getField("NRBUTTON").readOnly = 
		widget.getField("DSBUTTON").readOnly = 
		row.__is_new = true;
		row.ANTG_NRBUTTON = '';
		row.CDNATPRODUTO = null;
		row.IDTPBUTTON = 1;
		row.NMPRODUTO = General.getFieldValue('NMPRODUTO', 'Detalhamento');
		row.CDPRODUTO = General.getFieldValue('CDPRODUTO', 'Detalhamento');
		row.CDARVPROD = General.getFieldValue('CDARVPROD', 'Detalhamento');
		
		var filterData = !widget.appliedFilter ? widget.appliedFilter.FILTER_ROW : false; 
		
		if( !!filterData && !!filterData.CDFILIAL) {
			widget.getField('NMCONFTELA').readOnly = false;
			widget.getField('NMFILIAL').readOnly = true;
			row.NMFILIAL = filterData.NMFILIAL;
			row.CDFILIAL = filterData.CDFILIAL;
		} else {
			widget.getField('NMFILIAL').readOnly = false;
			widget.getField('NMCONFTELA').readOnly = true;
		}
		
		row.DSBUTTON2 = row.NMPRODUTO;
		row.NRFONTETEXT = TAMANHO_FONTE_PADRAO;
		row.NRCOLORBACK = '#fff';
		row.NRCOLORTEXT = '#ff5500';
		widget.currentRow = row;
		widget.reload();
	};
	
	this.editRowGruposDeProdutos = function(args) {
		var widget = args.owner.widget;
		General.widgetEdit(widget);
		widget.getField("NRBUTTON").readOnly = true;
		widget.currentRow.__is_new = false;
		widget.currentRow.ANTG_NRBUTTON = widget.currentRow.NRBUTTON;
		widget.reload();
	};
	
	this.changeFieldNRPGCONFTELA = function(args){
		var widget = args.owner.field.widget;
		if(args.owner.field.value() !== null){
			widget.getField("NRBUTTON").readOnly = false;
			widget.currentRow.NRBUTTON = "";
		}
	};
    
    this.grupoOnChange = function(args){
        var field = args.owner.field;
        var widget = field.widget;
        widget.currentRow.NRPGCONFTELA = '';
        field.widget.getField('NRPGCONFTELA').readOnly = (field.value() == null || field.value() == '');
        if((field.value() == null || field.value() == '')){	
        	field.widget.getField('NRPGCONFTELA').value(field.value());
        	field.widget.getField('NRBUTTON').value(field.value());
        	field.widget.getField('NRBUTTON').readOnly = (field.value() == null || field.value() == '');
        }
        widget.currentRow.NRCOLORBACK = this.colorChange(widget.currentRow.NRCOLORBACKGRUPO);
        widget.currentRow.NRCOLORTEXT = this.colorChange(widget.currentRow.NRCOLORTEXTGRUPO);
        templateManager.updateTemplate();
        widget.reload();
    };
    
    this.filialOnChange = function(args){
        var field = args.owner.field;
        field.widget.getField('NMCONFTELA').readOnly = (field.value() == null || field.value() == '');
        if((field.value() == null || field.value() == '')){	
        	field.widget.getField('NMCONFTELA').value(field.value());
        	field.widget.getField('DSBUTTON').value(field.value());
        	field.widget.getField('DSBUTTON').readOnly = (field.value() == null || field.value() == '');
        	field.widget.getField('NRPGCONFTELA').value(field.value());
        	field.widget.getField('NRPGCONFTELA').readOnly = (field.value() == null || field.value() == '');
        	field.widget.getField('NRBUTTON').value(field.value());
        	field.widget.getField('NRBUTTON').readOnly = (field.value() == null || field.value() == '');
        }
    };
    
    this.confgtelaOnChange = function(args){
        var field = args.owner.field;
        field.widget.getField('DSBUTTON').readOnly = (field.value() == null || field.value() == '');
        if((field.value() == null || field.value() == '')){	
        	field.widget.getField('DSBUTTON').value(field.value());
        	field.widget.getField('NRPGCONFTELA').value(field.value());
        	field.widget.getField('NRPGCONFTELA').readOnly = (field.value() == null || field.value() == '');
        	field.widget.getField('NRBUTTON').value(field.value());
        	field.widget.getField('NRBUTTON').readOnly = (field.value() == null || field.value() == '');
        }
    };

	this.setFilterNRBUTTON = function(field) {
		var row = field.widget.currentRow;
		var dataFilter = field.dataSourceFilter;
		dataFilter[2].value = row.NRCONFTELA;
		dataFilter[3].value = row.IDTPBUTONAUX;
		dataFilter[4].value = row.NRBUTTONAUX;
		dataFilter[5].value = row.NRPGCONFTAUX;
		dataFilter[6].value = row.IDTPBUTONAUX2;
		dataFilter[7].value = row.NRBUTTONAUX2;
		dataFilter[8].value = row.NRPGCONFTELA;
		dataFilter[9].value = row.CDGRUPO;
		dataFilter[10].value = row.PROPRIAPOSICAO;
		field.reload();
		
	};

	this.productsInsideGroupWidgetSaveAction = function(widget) {
		if (widget.isValid()) {
			widget.currentRow.NRORG = getLocalVar('NRORG');
			widget.currentRow.IDTPBUTONAUX = 2;
			//widget.currentRow.NRBUTTONAUX   = widget.currentRow.NRBUTTON;
			//widget.currentRow.NRPGCONFTAUX  = widget.currentRow.NRPGCONFTELAUX;
			widget.currentRow.CDIDENTBUTON = widget.currentRow.CDPRODUTO;
			widget.currentRow.CDNATPRODUTO = widget.currentRow.CDNATPROD ?  widget.currentRow.CDNATPROD : null;
			widget.currentRow.DSMESSAGEBUT = widget.currentRow.DSMESSAGEBUT ?  widget.currentRow.DSMESSAGEBUT : null;
			widget.currentRow.DSBUTTON = widget.currentRow.DSBUTTON2;
			widget.currentRow.CDOPERULTATU = getLocalVar('CDOPERADOR');
			widget.currentRow.DSENDEIMG = widget.currentRow.IMAGE;
			if (widget.currentRow.__is_new) { 
					widget.currentRow.IDTPBUTONAUX2 = '0';
					widget.currentRow.NRBUTTONAUX2 = '0';
					widget.currentRow.NRPGCONFTAUX2 = '0';
					self.setLocalVarsOnWidget(widget);
					widget.currentRow.CDGRUPO = widget.currentRow.NRPGCONFTELA + "" + widget.currentRow.NRBUTTON;
			}
			var hexBack = ColorPickerController.hexToRgb(widget.currentRow.NRCOLORBACK),
				hexText = ColorPickerController.hexToRgb(widget.currentRow.NRCOLORTEXT);
			widget.currentRow.NRCOLORBACK = ColorPickerController.RGBToTColor(hexBack.r, hexBack.g, hexBack.b);
			widget.currentRow.NRCOLORTEXT = ColorPickerController.RGBToTColor(hexText.r, hexText.g, hexText.b);


			General.widgetSave(widget).then(function() {

				widget.currentRow.changed = false;
				widget.currentRow.__is_new = false;
				ScreenService.closeSwipe();
				widget.reload();
			});

		}

	};

	this.setLocalVarsOnWidget = function(widget) {
		var row = widget.currentRow;

		row.DTULTATU = moment().format('DD/MM/YYYY HH:mm:ss');
		row.NRORG = getLocalVar('NRORG');
		row.CDOPERULTATU = getLocalVar('CDOPERADOR');
		row.NRORGULTATU = getLocalVar('NRORG');

		if (row.__is_new) {
			row.CDOPERINCLUSAO = getLocalVar('CDOPERADOR');
			row.NRORGINCLUSAO = getLocalVar('NRORG');
			row.DTINCLUSAO = moment().format('DD/MM/YYYY HH:mm:ss');
		}
	};
	
	this.buildImageInViewMode = function(wdgLogotipo){
        setTimeout(function(){
            if(!Util.isEmptyOrBlank(wdgLogotipo.currentRow.IMAGE)){
                var row = wdgLogotipo.currentRow.IMAGE;
                var fieldLogo = $('#span-field-IMAGE');
                var b64Image = typeof row === "object" ? row[0].b64File : row;
                var urlLogo = b64Image;
                var image = '<img src='+urlLogo+' class="img-responsive center-block img-cadEst">';
                if($('.img-responsive.center-block').length <= 0){
                    fieldLogo.find('img').remove();
                    fieldLogo.append(image);
                    fieldLogo.find('p').css({display:'none'});
                }
            }else{
                this.setDefaultImage();
            }
        }.bind(this), 50);
        wdgLogotipo.redraw();
    };
    
    this.setDefaultImage = function(){
        var fieldLogo = $('#span-field-IMAGE');
        fieldLogo.find('p').css({display:'none'});
        fieldLogo.find('img').remove();
        fieldLogo.append('<img></img>');
        fieldLogo.find('img').addClass('defaultImage');
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('LayoutController', LayoutController);
});
